parameter [3:0]			// FSM states - power down and active power down states are not modeled
  // Main states
  IDLE		= 4'h0,
  MRS		= 4'h1,
  AR		= 4'h2,
  RA		= 4'h3,
  READ		= 4'h4,
  WRITE		= 4'h5,
  PC		= 4'h6;

  
parameter [3:0]			// FSM transition commands
  NOP_T		= 4'h0,
  DESEL_T	= 4'h1,
  ACT_T		= 4'h2,
  PRE_T		= 4'h3,
  WRITE_T	= 4'h4,
  READ_T	= 4'h5,
  REFA_T	= 4'h6,
  MRS_T		= 4'h7;
parameter [3:0]			// FSM output commands to DDR SDRAM
  // Output vector fsm_cmd_out[3:0] created as following:
  //	{cs,ras,cas,we}
  DESEL_CMD	= 4'b1xxx,
  NOP_CMD	= 4'b0111,
  ACT_CMD	= 4'b0011,
  PRE_CMD	= 4'b0010,	// The same command as for PREA
  WRITE_CMD	= 4'b0100,	// The same command as for WRITEA
  READ_CMD	= 4'b0101,	// The same command as for READA
  REFA_CMD	= 4'b0001,
  REFS_CMD	= 4'b0001,
  REFSX_CMD	= 4'b0111,
  TERM_CMD	= 4'b0110,
  MRS_CMD	= 4'b0000;
  
parameter [3:0]
  NOP_VJ	= 4'b0000,
  WR_1		= 4'b0001,	// Write one burst
  RD_1		= 4'b0010,  // Read one burst
  MRS_SETUP	= 4'b0100;	// Command to set MRS register