// Testbench for DDR FSM


module tddr_cntrl;

parameter [3:0]			// FSM transition commands
	DESEL_T		= 4'd0,
	NOP_T		= 4'd1,
	ACT_T		= 4'd2,
	PRE_T		= 4'd3,
	PREA_T		= 4'd4,
	WRITE_T		= 4'd5,
	WRITEA_T	= 4'd6,
	READ_T		= 4'd7,
	READA_T		= 4'd8,
	REFA_T		= 4'd9,
	REFS_T		= 4'd10,
	REFSX_T		= 4'd11,
	TERM_T		= 4'd12,
	MRS_T		= 4'd13;


wire [12:0] ddr_a;
wire [3:0] ddr_cmd;
wire [1:0] ddr_ba;
wire [1:0] ddr_clk;
wire [15:0] ddr_dq;
wire [1:0] ddr_dm;
wire [1:0] ddr_dqs;
wire [31:0] ddr_data_out;
wire ddr_cke;
wire [63:0] ddr_test_out;
reg [1:0] ddr_pll_in;
reg ddr_pll_90;
reg [3:0] ddr_cmd_in;
reg [1:0] ddr_ba_in;
reg [12:0] ddr_r_in;
reg [8:0] ddr_c_in;
reg [31:0] ddr_data_in;
reg ddr_test_shift;
reg ddr_test_clk;

ddr_cntr dut (
ddr_a, ddr_cmd, ddr_ba, ddr_clk, 
ddr_dq, ddr_dm, ddr_dqs,ddr_data_out, ddr_cke, ddr_test_out,
ddr_pll_in, ddr_pll_90, ddr_cmd_in, ddr_ba_in, ddr_r_in,
ddr_c_in, ddr_data_in, ddr_test_shift, ddr_test_clk
);

reg [15:0] dq_input = 16'hFFFF;
reg [1:0] dqs_input = 2'b00;

assign ddr_dq = dq_input;

initial
  begin
    dut.ddr_count = 32'h00000000;
    dut.ddr_start_count = 16'h0000;
    ddr_pll_in[0] = 1'b0;
    ddr_pll_in[1] = 1'b1;
    ddr_pll_90 = 1'b0;
    ddr_cmd_in = 4'b0;
    ddr_ba_in = 2'b0;
    ddr_r_in = 13'b0;
    ddr_c_in = 9'b111111111;
    ddr_data_in[31:16] = 16'b0;
    ddr_data_in[15:0] = 16'hFFFF;
    #2800 ddr_cmd_in = 4'b0001;
    #20 ddr_cmd_in = 4'b0;
    #500 ddr_cmd_in = 4'b0010;
    #40 ddr_cmd_in = 4'b0;
    #2100 ddr_cmd_in = 4'b0001;
    #20 ddr_cmd_in = 4'b0;
  end

always
  begin
    #5 ddr_pll_90 = !ddr_pll_90;
    #5 ddr_pll_in[0]  = !ddr_pll_in[0];
    	 ddr_pll_in[1]  = !ddr_pll_in[1];
  end


endmodule